// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO24/DIO24_Linux_8.x.x.x_GSC_DN/include/dio24_utils.h $
// $Rev: 51503 $
// $Date: 2022-10-03 15:31:59 -0500 (Mon, 03 Oct 2022) $

// DIO24: Utilities Library: header file

#ifndef	__DIO24_UTILS_H__
#define	__DIO24_UTILS_H__

#include "dio24_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	dio24_close_util			(int fd, int index, int verbose);
int	dio24_init_util				(int verbose);
int dio24_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	dio24_open_util				(int device, int share, int index, int verbose, int* fd);
int	dio24_read_util				(int fd, int index, int verbose, void* dst, size_t bytes);

// IOCTL utility services

int	dio24_clock_count_rx		(int fd, int index, int verbose, u32* get);						// DIO24_IOCTL_CLOCK_COUNT_RX
int	dio24_clock_latch_fall_rx	(int fd, int index, int verbose, u32 set, u32* get);			// DIO24_IOCTL_CLOCK_LATCH_RX
int	dio24_clock_latch_rise_rx	(int fd, int index, int verbose, u32 set, u32* get);			// DIO24_IOCTL_CLOCK_LATCH_RX
int	dio24_gpio_dir_out			(int fd, int index, int verbose, s32 set, s32* get);			// DIO24_IOCTL_GPIO_DIR_OUT
int	dio24_gpio_rx				(int fd, int index, int verbose, s32* get);						// DIO24_IOCTL_GPIO_RX
int	dio24_gpio_tx				(int fd, int index, int verbose, s32 set, s32* get);			// DIO24_IOCTL_GPIO_TX
int	dio24_initialize			(int fd, int index, int verbose);								// DIO24_IOCTL_INITIALIZE
int	dio24_irq_fall_enable		(int fd, int index, int verbose, s32 set, s32* get);			// DIO24_IOCTL_IRQ_FALL_ENABLE
int	dio24_irq_fall_status		(int fd, int index, int verbose, s32* get);						// DIO24_IOCTL_IRQ_FALL_STATUS
int	dio24_irq_rise_enable		(int fd, int index, int verbose, s32 set, s32* get);			// DIO24_IOCTL_IRQ_RISE_ENABLE
int	dio24_irq_rise_status		(int fd, int index, int verbose, s32* get);						// DIO24_IOCTL_IRQ_RISE_STATUS
int	dio24_query					(int fd, int index, int verbose, s32 set, s32* get);			// DIO24_IOCTL_QUERY
int dio24_reg_mod				(int fd, int index, int verbose, u32 reg, u32 val, u32 mask);	// DIO24_IOCTL_REG_MOD
int	dio24_reg_read				(int fd, int index, int verbose, u32 reg, u32* val);			// DIO24_IOCTL_REG_READ
int	dio24_reg_write				(int fd, int index, int verbose, u32 reg, u32 val);				// DIO24_IOCTL_REG_WRITE
int	dio24_wait_cancel			(int fd, int index, int verbose, dio24_wait_t* wait);			// DIO24_IOCTL_WAIT_CANCEL
int	dio24_wait_event			(int fd, int index, int verbose, dio24_wait_t* wait);			// DIO24_IOCTL_WAIT_EVENT
int	dio24_wait_status			(int fd, int index, int verbose, dio24_wait_t* wait);			// DIO24_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	dio24_config_di		(int fd, int index, int verbose);
int	dio24_config_do		(int fd, int index, int verbose);
int	dio24_id_device		(int fd, int index, int verbose);

int	dio24_count_boards	(int verbose, s32* get);
int	dio24_id_driver		(void);
int	dio24_reg_list		(int fd, int detail);

const gsc_reg_def_t*	dio24_reg_get_def_id(u32 reg);
const gsc_reg_def_t*	dio24_reg_get_def_index(int index);
const char*				dio24_reg_get_desc(u32 reg);
const char*				dio24_reg_get_name(u32 reg);



#endif
