// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO24/DIO24_Linux_8.x.x.x_GSC_DN/utils/util_config_di.c $
// $Rev: 52986 $
// $Date: 2023-05-03 16:42:23 -0500 (Wed, 03 May 2023) $

// DIO24: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dio24_config_di
*
*	Purpose:
*
*		Configure the Digital Input services.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int	dio24_config_di(int fd, int index, int verbose)
{
	int	errs	= 0;

	if (verbose)
	{
		gsc_label_index("Digital Input Config.", index);
		printf("\n");
		gsc_label_level_inc();
	}

	errs	+= dio24_initialize		(fd, index, verbose);

	// Settings must be applied after the initialization call!

	errs	+= dio24_gpio_dir_out	(fd, index, verbose, 0, NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}


