// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO24/DIO24_Linux_8.x.x.x_GSC_DN/utils/util_gpio_rx.c $
// $Rev: 52986 $
// $Date: 2023-05-03 16:42:23 -0500 (Wed, 03 May 2023) $

// DIO24: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dio24_gpio_rx
*
*	Purpose:
*
*		Provide a visual wrapper for the DIO24_IOCTL_GPIO_RX service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio24_gpio_rx(int fd, int index, int verbose, s32* get)
{
	int	errs;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("GPIO Rx", index);

	ret		= dio24_ioctl(fd, DIO24_IOCTL_GPIO_RX, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%07lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


