// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO24/DIO24_Linux_8.x.x.x_GSC_DN/utils/util_wait_event.c $
// $Rev: 52986 $
// $Date: 2023-05-03 16:42:23 -0500 (Wed, 03 May 2023) $

// DIO24: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dio24_wait_event
*
*	Purpose:
*
*		Provide a visual wrapper for the DIO24_IOCTL_WAIT_EVENT service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		wait	This is the crieteria to use.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio24_wait_event(int fd, int index, int verbose, dio24_wait_t* wait)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Wait Event", index);

	ret		= dio24_ioctl(fd, DIO24_IOCTL_WAIT_EVENT, wait);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}



